#include <reg51.h>
sbit start=P3^2;
sbit end=P3^3;
sbit oe=P3^4;
sbit ale=P3^5;
sbit clock=P3^6;
unsigned char aray[]={'0','1','2','3','4','5','6','7','8','9'};
void delay()
{
	int k,l;
	for(k=0;k<100;k++)
		for(l=0;l<80;l++);
} 
void usDelay(int a)
{
	TMOD=0x22;
	TH0=256-(a/1.085);
	TR0=1;
	EA=1;
	ET0=1;

}
void abbas() interrupt 1
{
	
	clock=~clock;

}	
void init()
{
	TMOD=0x22;
	TH1=0xFD;
	SCON=0x50;
	TR1=1;
}
void sendString(unsigned char *a)
{
	while(*a!='\0')
	{
		SBUF=*a;
		while(TI==0);
		TI=0;
		a++;
	}
}
void sendChar(unsigned char ch)
{
	
	SBUF=ch;
	while(TI==0);
	TI=0;
}
	
void sendReading(unsigned char val)
{
	unsigned char l,m,h;
	l=val%10;
	m=(val/10)%10;
	h=(val/10)/10;
	sendChar(aray[h]);
	sendChar(aray[m]);
	sendChar(aray[l]);
	sendChar('C');
	sendChar(0x0d);
}
void selectSensor(unsigned char num)
{
	P1=num;
	delay();
}
void latch()
{
	ale=0;
	delay();
	ale=1;
}
void startConv()
{
	delay();
	start=0;
	delay();
	start=1;
}
void wait()
{
	while(end==1);
}
void get()
{
	delay();
	oe=0;
	delay();
	oe=1;
	
}
void main()
{
	unsigned char sensor=0,p;
	init();
	usDelay(50);
	while(1)
	{
		
		if(sensor==8)
			sensor=0;
		if(sensor==0)
		{
			sendString("**** Data from sensors **** ");
			sendChar(0x0d);
		}
		selectSensor(sensor);
		latch();	
		startConv();
		wait();
		get();
		p=P2;
		sendString("Sensor");
		sendChar(aray[sensor+1]);
		sendChar(':');
		sendReading(p);
		
		sensor++;
	}
}
